#include <bits/stdc++.h>
using namespace std;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin>>t;
    while(t--)
    {
        bool ok = true;
        int n,m;
        cin>>n>>m;
        long long a[n];
        long long b[m];
        for(int i=0;i<n;++i)cin>>a[i];
        for(int i=0;i<m;++i)cin>>b[i];

        sort(a,a+n);
        long long x=a[1]-a[0];
        for(int i=2;i<n;++i)x=min(x,a[i]-a[i-1]);

        long long mod=a[0]%x;
        for(int i=1;i<n;++i)if((a[i]%x)!=mod)
        {
            ok=false;
            break;
        }
        if(!ok)
        {
            cout<<0<<endl;
        }
        else
        {
            for(int i=0;i<m;++i)
            {
                if((b[i]%x)==mod)
                {
                    ok=false;
                    break;
                }
            }
            if(!ok)
            {
                cout<<0<<endl;
            }
            else
            {
                cout<<1<<endl;
            }
        }
    }
}